Codeforces 828C String Reconstruction【思维+并查集】

来源:互联网 发布:什么牌子钢笔好用 知乎 编辑:程序博客网 时间:2024/05/16 01:54

C. String Reconstruction
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Ivan had string s consisting of small English letters. However, his friend Julia decided to make fun of him and hid the strings. Ivan preferred making a new string to finding the old one.

Ivan knows some information about the string s. Namely, he remembers, that stringti occurs in strings at least ki times or more, he also remembers exactlyki positions where the stringti occurs in strings: these positions are xi, 1, xi, 2, ..., xi, ki. He remembersn such strings ti.

You are to reconstruct lexicographically minimal strings such that it fits all the information Ivan remembers. Stringsti and strings consist of small English letters only.

Input

The first line contains single integer n (1 ≤ n ≤ 105) — the number of strings Ivan remembers.

The next n lines contain information about the strings. Thei-th of these lines contains non-empty stringti, then positive integerki, which equal to the number of times the stringti occurs in strings, and then ki distinct positive integersxi, 1, xi, 2, ..., xi, ki in increasing order — positions, in which occurrences of the string ti in the strings start. It is guaranteed that the sum of lengths of stringsti doesn't exceed106, 1 ≤ xi, j ≤ 106,1 ≤ ki ≤ 106, and the sum of allki doesn't exceed106. The strings ti can coincide.

It is guaranteed that the input data is not self-contradictory, and thus at least one answeralways exists.

Output

Print lexicographically minimal string that fits all the information Ivan remembers.

Examples
Input
3a 4 1 3 5 7ab 2 1 5ca 1 4
Output
abacaba
Input
1a 1 3
Output
aaa
Input
3ab 1 1aba 1 3ab 2 3 5
Output
ababab

题目大意:


现在让你构造出来一个最小字典序的字符串,使得其满足n个条件。

这n个条件中每个条件有一个连续的子字符串。

然后有Ki个位子,表示这些字符串出现的位子。

保证有解,n个条件互相没有矛盾。



思路:


问题其实就是一个涂色问题。每次在Ki个点处作为起点,然后向后涂这个子字符串,如果已经涂过的位子不用再涂,否则涂上这个字母。

那么暴力去涂色肯定是要超时的。


我们维护一个并查集,使得find(x)查找到的位子是位子x之后,第一个没有涂色过的位子。

那么我们在暴力涂色的过程中,可以用并查集优化寻找速度。

很古老的套路题了= =


Ac代码:

#include<stdio.h>#include<string.h>#include<iostream>using namespace std;int f[3000000];char ans[3000000];char a[3000000];int find(int a){    int r=a;    while(f[r]!=r)    r=f[r];    int i=a;    int j;    while(i!=r)    {        j=f[i];        f[i]=r;        i=j;    }    return r;}void merge(int a,int b){    int A,B;    A=find(a);    B=find(b);    if(A>B)    {        f[B]=A;    }    else f[A]=B;}int main(){    int n;    while(~scanf("%d",&n))    {        memset(ans,' ',sizeof(ans));        int end=0;        for(int i=1;i<=3000000-80;i++)f[i]=i;        for(int i=1;i<=n;i++)        {            scanf("%s",a);            int lenn=strlen(a);            int ki;            scanf("%d",&ki);            while(ki--)            {                int x;                scanf("%d",&x);                int tmpx=x;                end=max(end,lenn+x-1);                while(x<=tmpx+lenn-1)                {                    ans[x]=a[x-tmpx+1-1];                    x=find(x);                    if(x<=tmpx+lenn-1)merge(x,x+1);                }            }        }        for(int i=1;i<=end;i++)        {            if(ans[i]==' ')ans[i]='a';            printf("%c",ans[i]);        }        printf("\n");    }}






















阅读全文
0 0
原创粉丝点击